<?php
if (!defined('ABSPATH')) {
	die;
}
class Event_Layer
{
    public function __construct()
    {
    }

    public function get_order($order_id, $refreshtoken)
    {
	    $frame = new Frame_Layer();
	    $api = new Api_Layer();
		
	    $frame_request = $frame->frame_request_order($order_id);
	    $handle_Contact = $api->handleContact($frame_request,$refreshtoken);
	    $order_frame_request = $frame->order_frame_request_order($handle_Contact,$order_id);	    
	    $sales_order_id = get_post_meta( $order_id, 'zoho_sales_order_id', true );
	    $invoice_order_id = get_post_meta( $order_id, 'zoho_invoice_order_id', true );
            $payment_order_id = get_post_meta( $order_id, 'zoho_payment_order_id', true );
		if($sales_order_id == '')
	    {
		    $zohoOrderID = $api->createZohoSalesOrder($order_frame_request,$refreshtoken);	  	    
		    $createSalesorderNote = $frame->createSaleOrderNote($zohoOrderID,$order_id);
	    }
	    else
	    {
		   $zohoOrderID = $api->getZohoSalesOrder($sales_order_id,$refreshtoken);			
	    }

	    if($zohoOrderID && $invoice_order_id == ''){
		    $invoice_frame_request = $frame->invoice_frame_request($order_frame_request,$zohoOrderID,$order_id);		    
		    $invoiceResp = $api->createZohoInvoice($invoice_frame_request,$refreshtoken);		    
		    $invoiceResp = json_decode($invoiceResp,TRUE);
		    $createInvoiceNote = $frame->createInvoiceNote($invoiceResp,$order_id);
	    }	    
	    else
	    {
                    $invoiceResp = $api->getZohoInvoice($invoice_order_id,$refreshtoken);		    
	    }

/*	    if(isset($invoiceResp['invoice']) && $payment_order_id == ''){
		    $payment_frame_request = $frame->payment_frame_request($handle_Contact,$invoiceResp,$order_id);		    
		    $paymentResponse = $api->createZohoPayment($payment_frame_request,$refreshtoken);		    
		    $paymentResp = json_decode($paymentResponse,TRUE);
		    $createPaymentNote = $frame->createPaymentNote($paymentResp,$order_id);
	    }
 */

	    return true;
    }

	function tax_sync_zohobooks($order)
	{
		$total_standardtax = 0;
		$eventobj = new Event_Layer();
		$apiobj = new Api_Layer();
		$mappingdata = $eventobj->get_mapping_taxrateid();
		$mappedzohotax = array();
		$i = 0;
		foreach ($order->get_items() as $item) {
			$item_taxes = $item->get_taxes();			
			foreach ($item_taxes['total'] as $rateid => $taxamount) {
				if (in_array($rateid, $mappingdata)) {
					$zohotax = array_search($rateid, $mappingdata);
					$mappedzohotax[$i]['name'] = $zohotax;
					$mappedzohotax[$i]['amount'] = $taxamount;
					$i++;
				}
			}
		}


		$zohotaxdetails = $eventobj->get_zohotaxdata($apiobj->get_taxDetails(), $mappedzohotax);
		
		return $zohotaxdetails;

		//  $product_id = $item->get_product_id();
		// error_log(print_r(['inside id--' => $product_id], true), 3, '/var/www/html/error.log');
		// die();

		// $tax_class = get_post_meta($product_id, '_tax_class', true);
		// $tax_rate = WC_Tax::get_rate_percent_by_tax_class($tax_class);
		// $product_price = $item->get_total() / $item->get_quantity();
		// $tax_amount = ($product_price * $tax_rate) / 100;
		// $total_standardtax += $tax_amount;
	}

	public function doProductSync() {
		$api = new Api_Layer();
		$zoho_auth = new zoho_auth();
		$generate_refersh_token = $zoho_auth->getAccessToken();
		$fields = get_option("woo_zoho_fields_map_json");
		$args = array(
			'post_type' => 'product',
			'posts_per_page' => -1
		);
		$loop = new WP_Query($args);
		while ($loop->have_posts()):
			$loop->the_post();
			global $product;
			$productJson = array();
			$productJsonCustom = array();
			$productId = $product->get_id();
			$productJsonRequest = $this->setProductjsonData($fields);
			// foreach ($fields as $zohoname => $woo_fdname) {
			// 	if(strstr($zohoname,'cf_')){
			// 		$zohoname = strtolower($zohoname);
			// 		$fdvalue = $this->getProductDetails($woo_fdname);

			// 		$productJsonCustom['custom_fields'][] = array("value" => $fdvalue, "api_name" => $zohoname);
			// 		continue;
			// 	}
			// 	$zohoname = strtolower($zohoname);
			// 	$productJson[$zohoname] = $this->getProductDetails($woo_fdname);				
			// }			

			// if (count($productJsonCustom) != 0) {				
			// 	$merge_Json = array_merge($productJson, $productJsonCustom);
			// 	$productJsonRequest = json_encode($merge_Json, TRUE);
			// } else {
			// 	$productJsonRequest = json_encode($productJson, TRUE);
			// }
			$api = new Api_Layer();
			error_log(print_r(['inside arry' => $productJsonRequest], true), 3, '/var/www/html/error.log');
			 
			$checkItem = $api->checkItemAlreadyExits($product->get_sku(), $generate_refersh_token);
			error_log(print_r(['inside iteme' => $checkItem], true), 3, '/var/www/html/error.log');
			if (count($checkItem['items']) == 0) {
				$itemsDetail = $api->createZohoItem($productJsonRequest, $generate_refersh_token);
				error_log(print_r(['inside iteme' => $itemsDetail], true), 3, '/var/www/html/error.log');				
				$itemsDetail = json_decode($itemsDetail, TRUE);
				$message = $itemsDetail['message'];
				$itemId = $itemsDetail['item']['item_id'];
				update_post_meta($productId, '_zoho_item_id', $itemId);
				
			} else {
				$itemId = $checkItem['items'][0]['item_id'];
				$itemsDetail = $api->updateZohoItem($productJsonRequest, $itemId, $generate_refersh_token);
				$itemsDetail = json_decode($itemsDetail, TRUE);
				$message = $itemsDetail['message'];			
			}
		endwhile;
		wp_reset_query();		
	}

	public function setProductjsonData($fields,$id = ""){
		foreach ($fields as $zohoname => $woo_fdname) {
			if (strstr($zohoname, 'cf_')) {
				$zohoname = strtolower($zohoname);
				$fdvalue = $this->getProductDetails($woo_fdname,$id);

				$productJsonCustom['custom_fields'][] = array("value" => $fdvalue, "api_name" => $zohoname);
				continue;
			}
			$zohoname = strtolower($zohoname);
			$productJson[$zohoname] = $this->getProductDetails($woo_fdname,$id);
		}

		if (isset($productJsonCustom) && count($productJsonCustom) != 0) {
			$merge_Json = array_merge($productJson, $productJsonCustom);
			$productJsonRequest = json_encode($merge_Json, TRUE);
		} else {
			$productJsonRequest = json_encode($productJson, TRUE);
		}
		return $productJsonRequest;
	}

	function getProductDetails($mapping_value,$id)
	{
		$mapping_value = strtolower($mapping_value);
		global $product;
		$productJson = array();
		if($id != "")
		$product = wc_get_product($id);
		if ($mapping_value == 'name') {
			$all_detail = $product->get_name();
		} elseif ($mapping_value == 'price') {
			$all_detail = $product->get_price();
		} elseif ($mapping_value == 'sku') {
			$all_detail = $product->get_sku();
		} elseif ($mapping_value == 'description') {
			$all_detail = $product->get_description();
		} elseif ($mapping_value == 'slug') {
			$all_detail = $product->get_slug();
		} elseif ($mapping_value == 'date_created') {
			$all_detail = $product->get_date_created();
		} elseif ($mapping_value == 'date_modified') {
			$all_detail = $product->get_date_modified();
		} elseif ($mapping_value == 'status') {
			$all_detail = $product->get_status();
		} elseif ($mapping_value == 'featured') {
			$all_detail = $product->get_featured();
		} elseif ($mapping_value == 'catalog_visibility') {
			$all_detail = $product->get_catalog_visibility();
		} elseif ($mapping_value == 'regular_price') {
			$all_detail = $product->get_regular_price();
		} elseif ($mapping_value == 'sale_price') {
			$all_detail = $product->get_sale_price();
		} elseif ($mapping_value == 'date_on_sale_from') {
			$all_detail = $product->get_date_on_sale_from();
		} elseif ($mapping_value == 'date_on_sale_to') {
			$all_detail = $product->get_date_on_sale_to();
		} elseif ($mapping_value == 'total_sales') {
			$all_detail = $product->get_total_sales();
		} elseif ($mapping_value == 'tax_status') {
			$all_detail = $product->get_tax_status();
		} elseif ($mapping_value == 'tax_class') {
			$all_detail = $product->get_tax_class();
		} elseif ($mapping_value == 'manage_stock') {
			$all_detail = $product->get_manage_stock();
		} elseif ($mapping_value == 'stock_quantity') {
			$all_detail = $product->get_stock_quantity();
		} elseif ($mapping_value == 'stock_status') {
			$all_detail = $product->get_stock_status();
		} elseif ($mapping_value == 'backorders') {
			$all_detail = $product->get_backorders();
		} elseif ($mapping_value == 'sold_individually') {
			$all_detail = $product->get_sold_individually();
		} elseif ($mapping_value == 'weight') {
			$all_detail = $product->get_weight();
		} elseif ($mapping_value == 'length') {
			$all_detail = $product->get_length();
		} else {
			$all_detail = '';
		}
		return $all_detail;
	}

	public function get_mapping_taxrateid() {
		global $wpdb;
		$newdata = array();
		$mapdata = get_option("tax_mappingdata");		
		//$mapdata = unserialize($mapdata);
		foreach($mapdata as $zohotax => $wootax ) {
			$taxdata = explode(" ", $wootax);
			$taxname = $taxdata[0] ? $taxdata[0] : "";
			$country = $taxdata[1] ? $taxdata[1] : "";
			$state = $taxdata[2] ? $taxdata[2] : "";

			$query = $wpdb->prepare("
    SELECT tr.tax_rate_id
    FROM {$wpdb->prefix}woocommerce_tax_rates AS tr   
    WHERE tr.tax_rate_name = %s    
    AND tr.tax_rate_country = %s
	AND tr.tax_rate_state = %s
", $taxname, $country, $state);
			$tax_rateid = $wpdb->get_var($query);			
			$newdata[$zohotax] = $tax_rateid;			
		}		
		return $newdata;
}

	public function store_tax($taxdata,$submitdata){	
		$taxdetails = array();
		foreach ($taxdata as $key => $data) {
			if($submitdata[$data['tax_name']])
				$taxdetails[$data['tax_name']] = $submitdata[$data['tax_name']];
		}
		update_option('tax_mappingdata', $taxdetails);
	}

	public function get_zohotaxdata($taxdata,$ordertaxdata) : array {		
		$i = $j = 0;
		error_log(print_r(['indide order' => $ordertaxdata],true),3,'/var/www/html/error.log');
		error_log(print_r(['indide ttt' => $taxdata], true), 3, '/var/www/html/error.log');

		foreach($ordertaxdata as $orderdata) {
			error_log(print_r(['indide odata' => $orderdata], true), 3, '/var/www/html/error.log');
			foreach ($taxdata as $key => $data) {
				if ($orderdata['name'] == $data['tax_name']) {
					error_log(print_r(['indide if' => $orderdata['name']], true), 3, '/var/www/html/error.log');
					$itemtax[$j]['tax_id'] = $data['tax_id'];
					$itemtax[$j]['tax_name'] = $data['tax_name'];
					//$itemtax[$j]['tax_amount'] = ceil($orderdata['amount']);			
				}
			}
			$j++;
		}
		foreach ($ordertaxdata as $orderdata) {
			foreach ($taxdata as $key => $data) {
				if ($orderdata['name'] == $data['tax_name']) {
					$taxdetails['id'][$i] = $data['tax_id'];
					$taxdetails['name'][$i] = $data['tax_name'];
					$taxdetails['type'][$i] = $data['tax_type'];
					$taxdetails['percentage'][$i] = $data['tax_percentage'];
					$taxdetails['line_item_tax'][$i] = $itemtax[$i];
				}
			}
			$i++;
		}
		error_log(print_r(['final err' => $taxdetails], true), 3, '/var/www/html/error.log');
		
		return $taxdetails;
	}

	public function get_taxrates() {
		$tax_classes = array();	
		$tax_classes = WC_Tax::get_tax_classes();
		array_unshift($tax_classes, '');
		foreach($tax_classes as $taxclass) {
			$taxdata = WC_Tax::get_rates_for_tax_class($taxclass);
			foreach($taxdata as $taxid => $data){				
				$taxclass = $taxclass == "" ? 'Standard rate' : $taxclass;
				$rates[$taxclass][] = $data->tax_rate_name . ' ' . $data->tax_rate_country . ' ' . $data->tax_rate_state; 
			}
		}	
		return $rates;
	}
}
