<?php

if (!defined('ABSPATH')) {
        die;
}
class Api_Layer
{
        public $domain = "";
        public $orgId = "";
        public function __construct()
        {
                $this->domain = $this->getDomain();
                $this->orgId = ($this->getorgId()) ? $this->getorgId() : 0;
        }

        public function handleContact($jsonString, $booksAccessToken)
        {
                global $syncDebug;
                $jsonString = json_decode($jsonString, true);
                $con_billing_address = $jsonString['billing_address'];
                $con_shipping_address = $jsonString['shipping_address'];
                $email = $jsonString['email'];
                $contact_list = $this->getAllZohoCustomer($email, $booksAccessToken);

                if (count($contact_list) > 0) {
                        $contactid = $contact_list[0]['contact_id'];
                        $contactDetails = $this->getZohoContactDetails($contactid, $booksAccessToken);
                        $contactPersonId = $contactDetails['contact']['contact_persons'][0]['contact_person_id'];
                        $billing_address = $contactDetails['contact']['billing_address'];
                        $shipping_address = $contactDetails['contact']['shipping_address'];
                        $result_billing = array_intersect($con_billing_address, $billing_address);
                        $sameAddress = count($result_billing);
                        if ($sameAddress == 7) {
                                $address_id = $billing_address['address_id'];
                        } else {
                                $jsonString = json_encode($jsonString);
                                $new_address = $this->createZohoAddress($contactid, $jsonString, $booksAccessToken);
                                $addressRes = json_decode($new_address, TRUE);
                                $address_id = $addressRes['address_info']['address_id'];
                        }

                } else {
                        $jsonString = json_encode($jsonString, true);
                        $new_contact = $this->createZohoCustomer($jsonString, $booksAccessToken);
                        $customerRes = json_decode($new_contact, TRUE);
                        $contactid = $customerRes['contact']['contact_id'];
                        $contactDetails = $this->getZohoContactDetails($contactid, $booksAccessToken);
                        $contactPersonId = $contactDetails['contact']['contact_persons'][0]['contact_person_id'];
                        $billing_address = $contactDetails['contact']['billing_address'];
                        $address_id = $billing_address['address_id'];
                }
                $contactDetail['contactid'] = $contactid;
                $contactDetail['address_id'] = $address_id;
                $contactDetail['contact_person_id'] = $contactPersonId;
                $contactDetail = json_encode($contactDetail, TRUE);

                return $contactDetail;

        }

        public function getAllZohoCustomer($customerEmail, $booksAccessToken)
        {
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/contacts?organization_id=" . $this->orgId . "&contact_type=customer&email=" . $customerEmail,
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "GET",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $booksAccessToken . "",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=66dbc7c6-9527-4514-a805-0bb1eaa86950; JSESSIONID=4171DCB12C87CDCE26F34267D9700BDD"
                        ),
                )
                );
                $response = curl_exec($curl);
                curl_close($curl);
                $response = json_decode($response, TRUE);
                return $response['contacts'];
        }

        public function getZohoContactDetails($contactId, $booksAccessToken)
        {
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/contacts/$contactId/?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "GET",
                        CURLOPT_POSTFIELDS => array('JSONString' => '{"tax_authority_name":\'dropandfloors\'}'),
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $booksAccessToken . "",
                                "Cookie: BuildCookie_680431061=1; ba05f91d88=0dbe339a33d8d81c0280b2f86b89b841; zbcscook=9104e49f-0f2d-4a11-a111-329a29aa05e5; JSESSIONID=A6C26FF7B91A3E076156E0CAC4C72755"
                        ),
                )
                );
                $response = curl_exec($curl);
                curl_close($curl);
                $response = json_decode($response, TRUE);
                return $response;
        }

        public function createZohoAddress($contactId, $jsonString, $booksAccessToken)
        {
                $jsonString = json_decode($jsonString, true);
                $arr = $jsonString['billing_address'];
                $jsonstr = json_encode($arr);
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/contacts/" . $contactId . "/address?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "POST",
                        CURLOPT_POSTFIELDS => "JSONString=$jsonstr",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $booksAccessToken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=66dbc7c6-9527-4514-a805-0bb1eaa86950; JSESSIONID=69E5AD7B96970B2930A8165AC882BC1B"
                        ),
                )
                );
                $response = curl_exec($curl);
                curl_close($curl);
                return $response;
        }

        function createZohoCustomer($jsonString, $booksAccessToken)
        {
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/contacts?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "POST",
                        CURLOPT_POSTFIELDS => "JSONString=$jsonString",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $booksAccessToken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=66dbc7c6-9527-4514-a805-0bb1eaa86950; JSESSIONID=69E5AD7B96970B2930A8165AC882BC1B"
                        ),
                )
                );

                $response = curl_exec($curl);
                curl_close($curl);
                return $response;
        }

        public function createZohoSalesOrder($orderJson, $booksAccessToken)
        {
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/salesorders?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "POST",
                        CURLOPT_POSTFIELDS => "JSONString=$orderJson",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $booksAccessToken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=66dbc7c6-9527-4514-a805-0bb1eaa86950; JSESSIONID=4171DCB12C87CDCE26F34267D9700BDD"
                        ),
                )
                );
                
                $response = curl_exec($curl);
                curl_close($curl);
                $orderData = false;                
                $response = json_decode($response, TRUE);
                
                if (isset($response['salesorder'])) {
                        $orderData['id'] = $response['salesorder']['salesorder_id'];
                        $orderData['name'] = $response['salesorder']['salesorder_number'];
                        foreach ($response['salesorder']['line_items'] as $resitems) {
                                $orderData[$resitems['item_id']] = $resitems['line_item_id'];
                        }
                }
                $orderData['message'] = $response['message'];
                return $orderData;
        }

        function getZohoSalesOrder($sales_order_id, $refreshtoken)
        {
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/salesorders/" . $sales_order_id . "?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "GET",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $refreshtoken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=66dbc7c6-9527-4514-a805-0bb1eaa86950; JSESSIONID=91278978A59F1803C59802220E302249"
                        ),
                )
                );

                $response = curl_exec($curl);
                curl_close($curl);

                $response = json_decode($response, TRUE);                
                if (isset($response['salesorder'])) {
                        $orderData['id'] = $response['salesorder']['salesorder_id'];
                        $orderData['name'] = $response['salesorder']['salesorder_number'];
                        foreach ($response['salesorder']['line_items'] as $resitems) {
                                $orderData[$resitems['item_id']] = $resitems['line_item_id'];
                        }
                }
                $orderData['message'] = $response['message'];
                return $orderData;
        }

        function createZohoInvoice($invoiceJson, $booksAccessToken)
        {

                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/invoices?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "POST",
                        CURLOPT_POSTFIELDS => "JSONString=$invoiceJson",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $booksAccessToken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_680431061=1; ba05f91d88=90891e66e822696d3e050430949175d4; zbcscook=0cf95b27-6a54-4b29-a101-d7f1e4acbeb0; JSESSIONID=F16A06437A5446C2701B6E9FCC22D8FF"
                        ),
                )
                );
                $response = curl_exec($curl);
                curl_close($curl);
                return $response;
        }

        public function getZohoInvoice($invoice_id, $refreshtoken)
        {
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/invoices/" . $invoice_id . "?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "GET",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $refreshtoken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=66dbc7c6-9527-4514-a805-0bb1eaa86950; JSESSIONID=91278978A59F1803C59802220E302249"
                        ),
                )
                );

                $response = curl_exec($curl);
                curl_close($curl);
                $response = json_decode($response, TRUE);
                return $response;
        }

        function createZohoPayment($paymentJson, $booksAccessToken)
        {

                $curl = curl_init();

                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/customerpayments?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "POST",
                        CURLOPT_POSTFIELDS => "JSONString=$paymentJson",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $booksAccessToken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=bd0ec4ad-40af-4e54-8c87-380d908b5a19; JSESSIONID=883D6888F01CB6A613DF18591DAEB77A"
                        ),
                )
                );
                $response = curl_exec($curl);
                curl_close($curl);
                return $response;
        }

        public function createZohoItem($productJsonRequest, $refreshtoken)
        {
                $curl = curl_init();

                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/items?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "POST",
                        CURLOPT_POSTFIELDS => "JSONString=$productJsonRequest",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $refreshtoken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=bd0ec4ad-40af-4e54-8c87-380d908b5a19; JSESSIONID=883D6888F01CB6A613DF18591DAEB77A"
                        ),
                )
                );
                $response = curl_exec($curl);
                curl_close($curl);
                error_log(print_r(['inside  resp curl' => $response], true), 3, '/var/www/html/error.log');
                return $response;
        }

        public function checkItemAlreadyExits($sku, $refreshtoken)
        {
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/items/?search_text=" . $sku . "&column_name=sku&organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "GET",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $refreshtoken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=66dbc7c6-9527-4514-a805-0bb1eaa86950; JSESSIONID=91278978A59F1803C59802220E302249"
                        ),
                )
                );

                $response = curl_exec($curl);
                curl_close($curl);
                $response = json_decode($response, TRUE);
                return $response;
        }

        public function getZohoItem($refreshtoken) {
           //  "https://www.zohoapis.com/crm/v5/settings/fields?module=Accounts&include=allowed_permissions_to_update"
               // https: //books.zoho.com/api/v3/settings/describe/contacts
                $curl = curl_init();
                curl_setopt_array(
                        $curl,
                        array(
                                CURLOPT_URL => $this->domain . "/items/1460354000000048194?organization_id=" . $this->orgId,
                                //CURLOPT_URL => "https://books.zoho.in/api/v3/organizations",
                                CURLOPT_RETURNTRANSFER => true,
                                CURLOPT_ENCODING => "",
                                CURLOPT_MAXREDIRS => 10,
                                CURLOPT_TIMEOUT => 0,
                                CURLOPT_FOLLOWLOCATION => true,
                                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                                CURLOPT_CUSTOMREQUEST => "GET",
                                CURLOPT_HTTPHEADER => array(
                                        "authorization: Zoho-oauthtoken " . $refreshtoken . "",
                                        "Content-Type: application/x-www-form-urlencoded",
                                        "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=66dbc7c6-9527-4514-a805-0bb1eaa86950; JSESSIONID=91278978A59F1803C59802220E302249"
                                ),
                        )
                );

                $response = curl_exec($curl);
                curl_close($curl);
                //error_log(print_r(['inside rrs' => $response], true), 3, '/var/www/html/error.log');
                
                $response = json_decode($response, TRUE);
                //error_log(print_r(['inside rrs2' => $response], true), 3, '/var/www/html/error.log');
                
                return $response;
        }

        public function updateZohoItem($productJsonRequest, $itemId, $refreshtoken)
        {
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/items/" . $itemId . "?organization_id=" . $this->orgId . "",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "PUT",
                        CURLOPT_POSTFIELDS => "JSONString=$productJsonRequest",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $refreshtoken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=bd0ec4ad-40af-4e54-8c87-380d908b5a19; JSESSIONID=883D6888F01CB6A613DF18591DAEB77A"
                        ),
                )
                );
                $response = curl_exec($curl);
                curl_close($curl);
                return $response;

        }

        public function getDomain()
        {
                $domain = get_option('zoho-books-domain');
                if ($domain == 'US') {
                        $domain_url = 'https://books.zoho.com/api/v3';
                } elseif ($domain == 'europe') {
                        $domain_url = 'https://books.zoho.eu/api/v3';
                } elseif ($domain == 'china') {
                        $domain_url = 'https://books.zoho.com.cn/api/v3';
                } elseif ($domain == 'india') {
                        $domain_url = 'https://books.zoho.in/api/v3';
                }
                return $domain_url;
        }

        function getOrgs($refreshtoken)
        {
                $curl = curl_init();
                curl_setopt_array($curl, array(
                        CURLOPT_URL => $this->domain . "/organizations",
                        //CURLOPT_URL => "https://books.zoho.in/api/v3/organizations",
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => "",
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => "GET",
                        CURLOPT_HTTPHEADER => array(
                                "authorization: Zoho-oauthtoken " . $refreshtoken . "",
                                "Content-Type: application/x-www-form-urlencoded",
                                "Cookie: BuildCookie_60002748709=1; 0cf7e798ce=de73ab13528f170ef0ff3fac3872e363; zbcscook=66dbc7c6-9527-4514-a805-0bb1eaa86950; JSESSIONID=91278978A59F1803C59802220E302249"
                        ),
                )
                );

                $response = curl_exec($curl);
                curl_close($curl);                
                $response = json_decode($response, TRUE);
                return $response;
        }

        public function getorgId()
        {
                $orgdata = get_option("zoho-books-org");                
                $orgId = $orgdata ? $orgdata : 0;
                return $orgId;
        }

        public function get_taxDetails()
        {
                $curl = curl_init();
                $zoho_auth = new zoho_auth();
                $booksAccessToken = $zoho_auth->getAccessToken();
                curl_setopt_array(
                        $curl,
                        array(
                                CURLOPT_URL => $this->domain . "/settings/taxes?organization_id=$this->orgId",
                                //CURLOPT_URL => "https://books.zoho.in/api/v3/settings/taxes?organization_id=60023358407",
                                CURLOPT_RETURNTRANSFER => true,
                                CURLOPT_ENCODING => "",
                                CURLOPT_MAXREDIRS => 10,
                                CURLOPT_TIMEOUT => 0,
                                CURLOPT_FOLLOWLOCATION => true,
                                CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                                CURLOPT_CUSTOMREQUEST => "GET",
                                CURLOPT_HTTPHEADER => array(
                                        "authorization: Zoho-oauthtoken " . $booksAccessToken . ""
                                ),
                        )
                );
                $response = curl_exec($curl);
                curl_close($curl);               
                $response = json_decode($response, true);                               
                return $response['taxes'] ? $response['taxes'] : false;
        }

}
