<?php
/**
 * Plugin Name: Woo-Zoho-Books
 * Description: Sync Products,orders to zoho books
 * Version: 1.00
 * Author: Saidharshan S
 * Text Domain: wooBooks
 **/
if (!defined('ABSPATH')) {
    die;
}

require_once plugin_dir_path(__FILE__) . 'admin/settings_initiate.php';
function wooBooks_load_files()
{
    $model = glob(__DIR__ . '/admin/includes/*.php');

    foreach ($model as $model_files) {
        require_once($model_files);
    }

    require_once plugin_dir_path(__FILE__) . 'admin/templates/woo-zoho-books-order-sync.php';
    require_once plugin_dir_path(__FILE__) . 'admin/templates/configuration.php';
    add_action('wp_ajax_zohosync', 'zohosync');
    add_action('wp_ajax_addfield', 'addcustomfield');
    add_action('wp_ajax_storeProduct', 'processProductData');

}

function addcustomfield()
{
    $labelname = sanitize_text_field($_POST['userfield']);
    $args = array(
        'post_type' => 'product',
        'taxonomy' => "product_cat",
    );
    $products = wc_get_products($args);
    foreach ($products as $key => $value) {
        $first = $value;
        $myArray = (array) $first;
        $prefix = chr(0) . '*' . chr(0);
        $fi = $myArray[$prefix . 'data'];
        $field_name = array();
        foreach ($fi as $key1 => $val) {
            $field_name[] = $key1;
        }
        break;
    }
    
    $newRowHtml = '<tr>' .
        '<th><label for="fields" data-key="'.$labelname.'">' .
        '<b>' . esc_html($labelname) . '</b></label></th>' .
        '<td>' .
        '<select name="fields[]" class="form_data" required>' .
        '<option value="">Choose_one</option>' ;
    foreach ($field_name as $item) {
        $newRowHtml .= '<option value="' . $item . '">' . $item . '</option>';       
    }
    $newRowHtml .= '</select>' .
        '</td>' .
        '</tr>';
    echo $newRowHtml;
    wp_die();
}

function processProductData() {
    error_log(print_r(['ppo' => $_POST], true), 3, '/var/www/html/error.log');
    $response = array();
    $eventobj = new Event_Layer();
    if(isset($_POST['map']) && is_array($_POST['map'])){
        $mapdata = $_POST['map'];
        update_option('woo_zoho_fields_map_json',$mapdata);
        $eventobj->doProductSync();
        $response['message'] = "Product sync was done Successfully";        
    }
    else {
        $response['message'] = "Map data was not saved.";       
    }
    echo wp_json_encode($response);
    wp_die();
}
function wooBooks_menu()
{
    add_menu_page('Woocommerce to Zoho books synz', 'Woocommerce to Zoho books synz', 'manage_options', 'wooBooks-sync', 'wooBooks_func');
    add_submenu_page('wooBooks-sync', 'Configuration Title', 'Get Code', 'manage_options', 'wooBooks-getCode', 'get_code');
    // add_action('admin_init', 'register_wooBooks_settings'); // wooBook_settings function available in settings file.
}
add_action('admin_menu', 'wooBooks_menu');

function wooBooks_register_menus()
{
    register_nav_menus(
        array(
            'wooBooks-menu' => 'Woo Books Menu',
            // This is the menu's name and description
        )
    );
}
add_action('init', 'wooBooks_register_menus');

function wooBooks_load_css_and_js()
{
    wp_enqueue_style('wooBooks_style', plugins_url('/admin/css/wooBooks_style.css', __FILE__));
    wp_enqueue_script('jquery');
    wp_enqueue_script('wooBooks_script', plugins_url('/admin/js/wooBooks_script.js', __FILE__));
    wp_localize_script('wooBooks_script', 'zoho_ajax_object', array('ajax_url' => admin_url('admin-ajax.php'), 'nonce' => wp_create_nonce('woo-zoho-books-sync')));
    // wp_enqueue_script( 'logs_datatables', plugins_url('/admin/js/logstable.js', __FILE__));
    //wp_localize_script( 'logs_datatables', 'zoho_ajax_url', array( 'ajax_url' => admin_url('admin-ajax.php?action=logs_datatables') ));
}

add_action('admin_menu', 'wooBooks_load_css_and_js');
add_action('plugins_loaded', 'wooBooks_load_files');